---------------------
PatchSet 3729 
Date: 2002/03/14 20:23:41
Author: serassio
Branch: nt-2_5
Tag: (none) 
Log:
Imported Windows patches from NT-2_3 and Cygwin-svc

Members: 
	include/config.h:1.5->1.5.18.1 
	include/radix.h:1.7->1.7.14.1 
	include/util.h:1.10->1.10.14.1 
	lib/ntlmauth.c:1.6->1.6.14.1 
	lib/util.c:1.12->1.12.14.1 
	snmplib/parse.c:1.2->1.2.14.1 
	src/cachemgr.c:1.6->1.6.14.1 
	src/comm.c:1.18.6.1->1.18.6.1.2.1 
	src/disk.c:1.8->1.8.22.1 
	src/fd.c:1.7->1.7.16.1 
	src/globals.h:1.14->1.14.14.1 
	src/helper.c:1.16->1.16.10.1 
	src/ipc.c:1.7->1.7.10.1 
	src/main.c:1.28.6.1->1.28.6.1.4.1 
	src/protos.h:1.41.6.3->1.41.6.3.4.1 
	src/squid.h:1.13.6.2->1.13.6.2.4.1 
	src/stat.c:1.13->1.13.10.1 
	src/store_dir.c:1.19->1.19.14.1 
	src/store_io.c:1.3->1.3.14.1 
	src/structs.h:1.48->1.48.6.1 
	src/tools.c:1.19->1.19.14.1 
	src/win32.c:1.5->1.5.14.1 
	src/fs/awin32/Makefile:1.1->1.1.2.1 
	src/fs/awin32/Makefile.am:1.1->1.1.18.1 
	src/fs/awin32/Makefile.in:1.1->1.1.62.1 
	src/fs/awin32/aiops.c:1.1->1.1.62.1 
	src/fs/awin32/async_io.c:1.1->1.1.62.1 
	src/fs/awin32/store_asyncufs.h:1.1->1.1.62.1 
	src/fs/awin32/store_dir_aufs.c:1.1->1.1.62.1 
	src/fs/awin32/store_io_aufs.c:1.1->1.1.62.1 
	src/fs/ufs/store_dir_ufs.c:1.21.6.1->1.21.6.1.4.1 

Index: squid/include/config.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/config.h,v
retrieving revision 1.5
retrieving revision 1.5.18.1
diff -u -r1.5 -r1.5.18.1
--- squid/include/config.h	13 Nov 2001 22:19:32 -0000	1.5
+++ squid/include/config.h	14 Mar 2002 20:23:41 -0000	1.5.18.1
@@ -105,7 +105,8 @@
 #define _SQUID_CYGWIN_
 
 #elif defined(WIN32) || defined(WINNT) || defined(__WIN32__) || defined(__WIN32)
-#define _SQUID_MSWIN_
+#define _SQUID_MSWIN_			      /* MS Compilers */
+#include "squid-mswin.h"
 
 #elif defined(__APPLE__)
 #define _SQUID_APPLE_
Index: squid/include/radix.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/radix.h,v
retrieving revision 1.7
retrieving revision 1.7.14.1
diff -u -r1.7 -r1.7.14.1
--- squid/include/radix.h	13 Nov 2001 22:19:33 -0000	1.7
+++ squid/include/radix.h	14 Mar 2002 20:23:41 -0000	1.7.14.1
@@ -1,5 +1,5 @@
 /*
- * $Id: radix.h,v 1.7 2001/11/13 22:19:33 squidadm Exp $
+ * $Id: radix.h,v 1.7.14.1 2002/03/14 20:23:41 serassio Exp $
  */
 
 #ifndef SQUID_RADIX_H
@@ -153,6 +153,8 @@
 extern struct squid_radix_node *squid_rn_search(void *, struct squid_radix_node *);
 extern struct squid_radix_node *squid_rn_search_m(void *, struct squid_radix_node *, void *);
 extern struct squid_radix_node *squid_rn_lookup(void *, void *, struct squid_radix_node_head *);
+#ifndef min
 #define min(x,y) ((x)<(y)? (x) : (y))
+#endif
 
 #endif /* SQUID_RADIX_H */
Index: squid/include/util.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/util.h,v
retrieving revision 1.10
retrieving revision 1.10.14.1
diff -u -r1.10 -r1.10.14.1
--- squid/include/util.h	17 Oct 2001 12:30:51 -0000	1.10
+++ squid/include/util.h	14 Mar 2002 20:23:41 -0000	1.10.14.1
@@ -1,5 +1,5 @@
 /*
- * $Id: util.h,v 1.10 2001/10/17 12:30:51 squidadm Exp $
+ * $Id: util.h,v 1.10.14.1 2002/03/14 20:23:41 serassio Exp $
  *
  * AUTHOR: Harvest Derived
  *
@@ -44,11 +44,13 @@
 #include <sys/time.h>
 #endif
 
-#if !defined(SQUIDHOSTNAMELEN)
+#if !defined(SQUIDHOSTNAMELEN)
+#ifndef _SQUID_MSWIN_
 #include <sys/param.h>
 #ifndef _SQUID_NETDB_H_		/* need protection on NEXTSTEP */
 #define _SQUID_NETDB_H_
 #include <netdb.h>
+#endif
 #endif
 #if !defined(MAXHOSTNAMELEN) || (MAXHOSTNAMELEN < 128)
 #define SQUIDHOSTNAMELEN 128
@@ -131,5 +133,19 @@
  * Returns the amount of known allocated memory
  */
 int statMemoryAccounted(void);
+
+/* CygWin & Windows NT Port */ 
+/* win32lib.c */
+#ifdef _SQUID_MSWIN_
+extern int chroot (const char *);
+extern int ftruncate(int, off_t);
+extern int gettimeofday(struct timeval * ,void *);
+extern int kill(pid_t, int);
+extern int statfs(const char *, struct statfs *);
+extern int truncate(const char *, off_t);
+extern const char * wsastrerror(int);
+extern struct passwd *getpwnam(char *);
+extern struct group *getgrnam(char *);
+#endif
 
 #endif /* SQUID_UTIL_H */
Index: squid/lib/util.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/util.c,v
retrieving revision 1.12
retrieving revision 1.12.14.1
diff -u -r1.12 -r1.12.14.1
--- squid/lib/util.c	18 Oct 2001 20:52:10 -0000	1.12
+++ squid/lib/util.c	14 Mar 2002 20:23:42 -0000	1.12.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: util.c,v 1.12 2001/10/18 20:52:10 squidadm Exp $
+ * $Id: util.c,v 1.12.14.1 2002/03/14 20:23:42 serassio Exp $
  *
  * DEBUG: 
  * AUTHOR: Harvest Derived
@@ -32,6 +32,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
  *
  */
+#define UTIL_C
 
 #define _etext etext
 
Index: squid/snmplib/parse.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/snmplib/parse.c,v
retrieving revision 1.2
retrieving revision 1.2.14.1
diff -u -r1.2 -r1.2.14.1
--- squid/snmplib/parse.c	18 Oct 2001 20:52:10 -0000	1.2
+++ squid/snmplib/parse.c	14 Mar 2002 20:23:42 -0000	1.2.14.1
@@ -107,6 +107,11 @@
 };
 
 int Line = 1;
+
+#ifdef _SQUID_MSWIN_
+#undef OPAQUE
+#undef OPTIONAL
+#endif
 
 /* types of tokens */
 #define	CONTINUE    -1
Index: squid/src/cachemgr.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/cachemgr.c,v
retrieving revision 1.6
retrieving revision 1.6.14.1
diff -u -r1.6 -r1.6.14.1
--- squid/src/cachemgr.c	18 Oct 2001 20:52:11 -0000	1.6
+++ squid/src/cachemgr.c	14 Mar 2002 20:23:43 -0000	1.6.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cachemgr.c,v 1.6 2001/10/18 20:52:11 squidadm Exp $
+ * $Id: cachemgr.c,v 1.6.14.1 2002/03/14 20:23:43 serassio Exp $
  *
  * DEBUG: section 0     CGI Cache Manager
  * AUTHOR: Duane Wessels
@@ -169,7 +169,11 @@
 static void error_html(const char *msg);
 static char *menu_url(cachemgr_request * req, const char *action);
 static int parse_status_line(const char *sline, const char **statusStr);
+#ifdef _SQUID_MSWIN_
+static cachemgr_request *read_request(char *);
+#else
 static cachemgr_request *read_request(void);
+#endif
 static char *read_get_request(void);
 static char *read_post_request(void);
 
@@ -178,6 +182,45 @@
 static void reset_auth(cachemgr_request * req);
 static const char *make_auth_header(const cachemgr_request * req);
 
+#ifdef _SQUID_MSWIN_
+static int s_iInitCount = 0;
+int Win32SockInit(void)
+{
+    int iVersionRequested;
+    WSADATA wsaData;
+    int err;
+
+    if (s_iInitCount > 0) {
+	s_iInitCount++;
+	return (0);
+    }
+    else if (s_iInitCount < 0)
+	return (s_iInitCount);
+
+    /* s_iInitCount == 0. Do the initailization */
+    iVersionRequested = MAKEWORD(2, 0);
+    err = WSAStartup((WORD) iVersionRequested, &wsaData);
+    if (err) {
+	s_iInitCount = -1;
+	return (s_iInitCount);
+    }
+    if (LOBYTE(wsaData.wVersion) != 2 ||
+	HIBYTE(wsaData.wVersion) != 0) {
+	s_iInitCount = -2;
+	WSACleanup();
+	return (s_iInitCount);
+    }
+    s_iInitCount++;
+    return (s_iInitCount);
+}
+
+void Win32SockCleanup(void)
+{
+    if (--s_iInitCount == 0)
+	WSACleanup();
+    return;
+}
+#endif /* ifdef _SQUID_MSWIN_ */
 
 static const char *
 safe_str(const char *str)
@@ -398,7 +441,12 @@
 read_reply(int s, cachemgr_request * req)
 {
     char buf[4 * 1024];
+#ifdef _SQUID_MSWIN_
+    int reply;
+    FILE *fp = tmpfile();
+#else
     FILE *fp = fdopen(s, "r");
+#endif
     /* interpretation states */
     enum {
 	isStatusLine, isHeaders, isBodyStart, isBody, isForward, isEof, isForwardEof, isSuccess, isError
@@ -415,6 +463,11 @@
 	perror("fdopen");
 	return 1;
     }
+#ifdef _SQUID_MSWIN_
+    while ((reply=recv(s,buf,sizeof(buf),0))>0)
+	fwrite(buf,1,reply,fp);
+    rewind(fp);
+#endif
     if (parse_menu)
 	action = "menu";
     /* read reply interpreting one line at a time depending on state */
@@ -507,6 +560,9 @@
     static struct sockaddr_in S;
     int s;
     int l;
+#ifdef _SQUID_MSWIN_
+    int answer;
+#endif
     static char buf[2 * 1024];
     if (req == NULL) {
 	auth_html(CACHEMGR_HOSTNAME, CACHE_HTTP_PORT, "");
@@ -555,9 +611,19 @@
 	req->hostname,
 	req->action,
 	make_auth_header(req));
+#ifdef _SQUID_MSWIN_
+    send(s, buf, l,0);
+#else
     write(s, buf, l);
+#endif
     debug(1) fprintf(stderr, "wrote request: '%s'\n", buf);
+#ifdef _SQUID_MSWIN_
+    answer=read_reply(s, req);
+    close(s);
+    return answer;
+#else
     return read_reply(s, req);
+#endif
 }
 
 int
@@ -565,16 +631,31 @@
 {
     char *s;
     cachemgr_request *req;
+#ifdef _SQUID_MSWIN_
+    int answer;
+#endif
     safe_inet_addr("255.255.255.255", &no_addr);
     now = time(NULL);
+#ifdef _SQUID_MSWIN_
+    Win32SockInit();
+    if ((s = strrchr(argv[0], '\\')))
+#else
     if ((s = strrchr(argv[0], '/')))
+#endif
 	progname = xstrdup(s + 1);
     else
 	progname = xstrdup(argv[0]);
     if ((s = getenv("SCRIPT_NAME")) != NULL)
 	script_name = xstrdup(s);
+#ifdef _SQUID_MSWIN_
+    req = read_request(NULL);
+    answer=process_request(req);
+    Win32SockCleanup();
+    return answer;
+#else
     req = read_request();
     return process_request(req);
+#endif
 }
 
 static char *
@@ -606,10 +687,16 @@
     return xstrdup(s);
 }
 
+#ifdef _SQUID_MSWIN_
+static cachemgr_request *
+read_request(char* buf)
+{
+#else
 static cachemgr_request *
 read_request(void)
 {
     char *buf;
+#endif
     cachemgr_request *req;
     char *s;
     char *t;
@@ -620,7 +707,11 @@
 	(void) 0;
     else
 	return NULL;
+#ifdef _SQUID_MSWIN_
+    if (strlen(buf) == 0 || strlen(buf) == 4000)
+#else
     if (strlen(buf) == 0)
+#endif
 	return NULL;
     req = xcalloc(1, sizeof(cachemgr_request));
     for (s = strtok(buf, "&"); s != NULL; s = strtok(NULL, "&")) {
Index: squid/src/comm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm.c,v
retrieving revision 1.18.6.1
retrieving revision 1.18.6.1.2.1
diff -u -r1.18.6.1 -r1.18.6.1.2.1
--- squid/src/comm.c	27 Feb 2002 09:18:08 -0000	1.18.6.1
+++ squid/src/comm.c	14 Mar 2002 20:23:43 -0000	1.18.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm.c,v 1.18.6.1 2002/02/27 09:18:08 squidadm Exp $
+ * $Id: comm.c,v 1.18.6.1.2.1 2002/03/14 20:23:43 serassio Exp $
  *
  * DEBUG: section 5     Socket Functions
  * AUTHOR: Harvest Derived
@@ -32,7 +32,8 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
  *
  */
-
+#ifndef COMM_C
+#define COMM_C
 #include "squid.h"
 
 #if defined(_SQUID_CYGWIN_)
@@ -173,7 +174,7 @@
     const char *note)
 {
     int new_socket;
-    int tos = 0;
+    int tos;
     fde *F = NULL;
 
     /* Create socket for accepting new connections. */
@@ -774,15 +775,20 @@
 {
     int flags;
     int dummy = 0;
-#ifdef _SQUID_CYGWIN_
+#if defined (_SQUID_CYGWIN_) || defined (_SQUID_MSWIN_)
     int nonblocking = TRUE;
+#ifdef _SQUID_CYGWIN_    
     if (fd_table[fd].type != FD_PIPE) {
+#endif
 	if (ioctl(fd, FIONBIO, &nonblocking) < 0) {
 	    debug(50, 0) ("commSetNonBlocking: FD %d: %s %D\n", fd, xstrerror(), fd_table[fd].type);
 	    return COMM_ERROR;
 	}
+#ifdef _SQUID_CYGWIN_    
     } else {
 #endif
+#endif
+#ifndef _SQUID_MSWIN_
 	if ((flags = fcntl(fd, F_GETFL, dummy)) < 0) {
 	    debug(50, 0) ("FD %d: fcntl F_GETFL: %s\n", fd, xstrerror());
 	    return COMM_ERROR;
@@ -791,6 +797,7 @@
 	    debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, xstrerror());
 	    return COMM_ERROR;
 	}
+#endif
 #ifdef _SQUID_CYGWIN_
     }
 #endif
@@ -801,13 +808,18 @@
 int
 commUnsetNonBlocking(int fd)
 {
-    int flags;
     int dummy = 0;
+#ifdef _SQUID_MSWIN_
+    int nonblocking = FALSE;
+    if (ioctlsocket(fd, FIONBIO, (unsigned long *) &nonblocking) < 0) {
+#else
+    int flags;
     if ((flags = fcntl(fd, F_GETFL, dummy)) < 0) {
 	debug(50, 0) ("FD %d: fcntl F_GETFL: %s\n", fd, xstrerror());
 	return COMM_ERROR;
     }
     if (fcntl(fd, F_SETFL, flags & (~SQUID_NONBLOCK)) < 0) {
+#endif
 	debug(50, 0) ("commUnsetNonBlocking: FD %d: %s\n", fd, xstrerror());
 	return COMM_ERROR;
     }
@@ -999,3 +1011,4 @@
 	}
     }
 }
+#endif /* COMM_C */
Index: squid/src/disk.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/disk.c,v
retrieving revision 1.8
retrieving revision 1.8.22.1
diff -u -r1.8 -r1.8.22.1
--- squid/src/disk.c	16 Aug 2001 07:39:03 -0000	1.8
+++ squid/src/disk.c	14 Mar 2002 20:23:43 -0000	1.8.22.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: disk.c,v 1.8 2001/08/16 07:39:03 squidadm Exp $
+ * $Id: disk.c,v 1.8.22.1 2002/03/14 20:23:43 serassio Exp $
  *
  * DEBUG: section 6     Disk I/O Routines
  * AUTHOR: Harvest Derived
@@ -60,17 +60,39 @@
 file_open(const char *path, int mode)
 {
     int fd;
+#ifdef _SQUID_MSWIN_ 
+    char fmode[4]="";
+    FILE * fbuf;
+#endif
     if (mode & O_WRONLY)
 	mode |= O_APPEND;
+#ifdef _SQUID_MSWIN_ 
+    mode |= _O_BINARY;
+    errno = 0;
+    if (mode & O_WRONLY) {
+	if (mode & O_TRUNC)
+	    strcpy(fmode,"wb");
+	else
+    	    strcpy(fmode,"a+b");
+	}
+	else
+	    strcpy(fmode,"rb");
+	fbuf=fopen(path,fmode);
+    fd = (fbuf != NULL) ? fileno(fbuf) : -1;
+#else
     mode |= SQUID_NONBLOCK;
     errno = 0;
     fd = open(path, mode, 0644);
+#endif
     statCounter.syscalls.disk.opens++;
     if (fd < 0) {
 	debug(50, 3) ("file_open: error opening file %s: %s\n", path,
 	    xstrerror());
 	fd = DISK_ERROR;
     } else {
+#ifdef _SQUID_MSWIN_ 
+	fd_table[fd].fbuf=fbuf;
+#endif
 	debug(6, 5) ("file_open: FD %d\n", fd);
 	commSetCloseOnExec(fd);
 	fd_open(fd, FD_FILE, path);
@@ -83,6 +105,9 @@
 void
 file_close(int fd)
 {
+#ifdef _SQUID_MSWIN_
+    FILE *fbuf;
+#endif
     fde *F = &fd_table[fd];
     PF *read_callback;
     assert(fd >= 0);
@@ -114,7 +139,15 @@
 #if CALL_FSYNC_BEFORE_CLOSE
     fsync(fd);
 #endif
+#ifdef _SQUID_MSWIN_
+    fbuf = fd_table[fd].fbuf;
+    if (fbuf == NULL)
+	close(fd);
+    else 
+	fclose(fbuf);
+#else
     close(fd);
+#endif
     debug(6, F->flags.close_request ? 2 : 5)
 	("file_close: FD %d, really closing\n", fd);
     fd_close(fd);
Index: squid/src/fd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fd.c,v
retrieving revision 1.7
retrieving revision 1.7.16.1
diff -u -r1.7 -r1.7.16.1
--- squid/src/fd.c	26 Aug 2001 22:26:29 -0000	1.7
+++ squid/src/fd.c	14 Mar 2002 20:23:43 -0000	1.7.16.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: fd.c,v 1.7 2001/08/26 22:26:29 squidadm Exp $
+ * $Id: fd.c,v 1.7.16.1 2002/03/14 20:23:43 serassio Exp $
  *
  * DEBUG: section 51    Filedescriptor Functions
  * AUTHOR: Duane Wessels
@@ -96,13 +96,21 @@
 int
 default_read_method(int fd, char *buf, int len)
 {
+#ifdef _SQUID_MSWIN_
+    return (fread(buf, 1, len, fd_table[fd].fbuf));
+#else
     return (read(fd, buf, len));
+#endif
 }
 
 int
 default_write_method(int fd, const char *buf, int len)
 {
-    return (write(fd, buf, len));
+#ifdef _SQUID_MSWIN_
+    return (fwrite(buf, 1, len, fd_table[fd].fbuf));
+#else
+    return (write(fd, buf, len));
+#endif
 }
 
 void
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.14
retrieving revision 1.14.14.1
diff -u -r1.14 -r1.14.14.1
--- squid/src/globals.h	18 Oct 2001 20:52:11 -0000	1.14
+++ squid/src/globals.h	14 Mar 2002 20:23:44 -0000	1.14.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: globals.h,v 1.14 2001/10/18 20:52:11 squidadm Exp $
+ * $Id: globals.h,v 1.14.14.1 2002/03/14 20:23:44 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -159,7 +159,14 @@
 extern int incoming_sockets_accepted;
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
 extern unsigned int WIN32_OS_version;	/* 0 */
-extern char *WIN32_OS_string;
+extern char *WIN32_OS_string;    /* NULL */	
+extern char *WIN32_Service_name; /* NULL */
+extern char *WIN32_Command_Line; /* NULL */
+extern char *WIN32_Service_Command_Line; /* NULL */
+extern unsigned int WIN32_run_mode;	/* _WIN_SQUID_RUN_MODE_INTERACTIVE */
+#if defined(_SQUID_MSWIN_) && defined(_DEBUG)
+extern int do_debug;	/* 0 */
+#endif
 #endif
 
 #endif /* SQUID_GLOBALS_H */
Index: squid/src/helper.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/helper.c,v
retrieving revision 1.16
retrieving revision 1.16.10.1
diff -u -r1.16 -r1.16.10.1
--- squid/src/helper.c	28 Nov 2001 23:29:52 -0000	1.16
+++ squid/src/helper.c	14 Mar 2002 20:23:44 -0000	1.16.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: helper.c,v 1.16 2001/11/28 23:29:52 squidadm Exp $
+ * $Id: helper.c,v 1.16.10.1 2002/03/14 20:23:44 serassio Exp $
  *
  * DEBUG: section 29    Helper process maintenance
  * AUTHOR: Harvest Derived?
@@ -32,6 +32,8 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
  *
  */
+#ifndef HELPER_C
+#define HELPER_C
 
 #include "squid.h"
 
@@ -73,6 +75,11 @@
     int rfd;
     int wfd;
     wordlist *w;
+#ifdef _SQUID_MSWIN_
+    HANDLE hIpc;
+    pid_t pid;
+#endif
+
     if (hlp->cmdline == NULL)
 	return;
     progname = hlp->cmdline->key;
@@ -97,7 +104,11 @@
 	    args,
 	    shortname,
 	    &rfd,
-	    &wfd);
+	    &wfd
+#ifdef _SQUID_MSWIN_
+	    , &hIpc, &pid
+#endif
+	    );
 	if (x < 0) {
 	    debug(29, 1) ("WARNING: Cannot run '%s' process.\n", progname);
 	    continue;
@@ -112,6 +123,10 @@
 	srv->buf_sz = 8192;
 	srv->offset = 0;
 	srv->parent = hlp;
+#ifdef _SQUID_MSWIN_
+	srv->hIpc = hIpc;
+	srv->pid = pid;
+#endif
 	cbdataLock(hlp);	/* lock because of the parent backlink */
 	dlinkAddTail(srv, &srv->link, &hlp->servers);
 	if (rfd == wfd) {
@@ -149,6 +164,11 @@
     int rfd;
     int wfd;
     wordlist *w;
+#ifdef _SQUID_MSWIN_
+    HANDLE hIpc;
+    pid_t pid;
+#endif
+
     if (hlp->cmdline == NULL)
 	return;
     progname = hlp->cmdline->key;
@@ -173,7 +193,11 @@
 	    args,
 	    shortname,
 	    &rfd,
-	    &wfd);
+	    &wfd
+#ifdef _SQUID_MSWIN_
+	    , &hIpc, &pid
+#endif
+	    );
 	if (x < 0) {
 	    debug(29, 1) ("WARNING: Cannot run '%s' process.\n", progname);
 	    continue;
@@ -507,6 +531,11 @@
 {
     dlink_node *link = hlp->servers.head;
     helper_server *srv;
+#ifdef _SQUID_MSWIN_
+    HANDLE hIpc;
+    pid_t pid;
+    int no;
+#endif
     while (link) {
 	srv = link->data;
 	link = link->next;
@@ -527,8 +556,25 @@
 	    continue;
 	}
 	srv->flags.closing = 1;
+#ifdef _SQUID_MSWIN_
+	hIpc = srv->hIpc;
+	pid = srv->pid;
+	no = srv->index + 1;
+	shutdown(srv->rfd, SD_BOTH);
+#endif
 	comm_close(srv->wfd);
 	srv->wfd = -1;
+#ifdef _SQUID_MSWIN_
+	if (hIpc) {
+	    if (WaitForSingleObject(hIpc, 5000) != WAIT_OBJECT_0) {
+		getCurrentTime();
+		debug(34, 1) ("helperShutdown: WARNING: %s #%d (%s,%ld) "
+		    "didn't exit in 5 seconds\n",
+		    hlp->id_name, no, hlp->cmdline->key, pid);
+	    }
+	    CloseHandle(hIpc);
+	}
+#endif
     }
 }
 
@@ -1115,3 +1161,4 @@
     xfree(r->buf);
     memFree(r, MEM_HELPER_STATEFUL_REQUEST);
 }
+#endif /* HELPER_C */
